/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg;

import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.*;

/**
 *
 * @author omozegieaziegbe
 */
public class JdbcToExcelExporter {

    public static void main(String[] args) {
        String jdbcUrl = "jdbc:mysql://localhost:3306/customer";
        String username = "root";
        String password = "omozegie";
        String sql = "SELECT * FROM customers";

        try (Connection conn = DriverManager.getConnection(jdbcUrl, username, password); Statement stmt = conn.createStatement(); ResultSet rs = stmt.executeQuery(sql); Workbook workbook = new XSSFWorkbook()) {

            Sheet sheet = workbook.createSheet("Data");
            writeHeader(rs, sheet);
            writeData(rs, sheet);

            try (FileOutputStream fileOut = new FileOutputStream("ResultSetOutput.xlsx")) {
                workbook.write(fileOut);
            }

            System.out.println("Excel file has been generated successfully!");

        } catch (SQLException | IOException e) {
        }
    }

    private static void writeHeader(ResultSet rs, Sheet sheet) throws SQLException {
        ResultSetMetaData metaData = rs.getMetaData();
        Row headerRow = sheet.createRow(0);
        int columnCount = metaData.getColumnCount();

        for (int i = 1; i <= columnCount; i++) {
            Cell cell = headerRow.createCell(i - 1);
            cell.setCellValue(metaData.getColumnLabel(i));
        }
    }

    private static void writeData(ResultSet rs, Sheet sheet) throws SQLException {
        int rowNum = 1;
        while (rs.next()) {
            Row row = sheet.createRow(rowNum++);
            int columnCount = rs.getMetaData().getColumnCount();

            for (int i = 1; i <= columnCount; i++) {
                Cell cell = row.createCell(i - 1);
                cell.setCellValue(rs.getString(i));
            }
        }
    }
}
